package dev.ninjdai.werewolf.commands;

import dev.ninjdai.werewolf.uhc.UHCPlayer;
import net.minestom.server.command.builder.Command;
import net.minestom.server.command.builder.arguments.ArgumentType;
import net.minestom.server.command.builder.arguments.minecraft.ArgumentEntity;
import net.minestom.server.entity.damage.Damage;
import net.minestom.server.entity.damage.DamageType;
import net.minestom.server.utils.entity.EntityFinder;

public class PlayerKillCommand extends Command {
    static final ArgumentEntity singlePlayerArgument = ArgumentType.Entity("player").onlyPlayers(true).singleEntity(true);
    public PlayerKillCommand() {
        super("playerkill");
        

        addSyntax(((sender, context) -> {
            if(! (sender instanceof UHCPlayer senderPlayer)) return;
            EntityFinder finder = context.get(singlePlayerArgument);
            UHCPlayer player = (UHCPlayer) finder.findFirstPlayer(sender);

            if (player == null) {
                sender.sendMessage("Couldn't find player");
                return;
            }
            player.damage(new Damage(DamageType.MOB_ATTACK, senderPlayer, senderPlayer, senderPlayer.getPosition(), 40));
        }), singlePlayerArgument);
    }
}
