package dev.ninjdai.werewolf.uhc;

import dev.ninjdai.werewolf.uhc.roles.Role;
import dev.ninjdai.werewolf.uhc.roles.Roles;
import dev.ninjdai.werewolf.uhc.teams.Team;
import dev.ninjdai.werewolf.uhc.teams.Teams;
import io.github.togar2.pvp.player.CombatPlayerImpl;
import lombok.Getter;
import lombok.Setter;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.GameMode;
import net.minestom.server.network.packet.server.play.WorldBorderSizePacket;
import net.minestom.server.network.player.PlayerConnection;
import net.minestom.server.potion.Potion;
import net.minestom.server.potion.PotionEffect;
import org.jetbrains.annotations.NotNull;

import java.util.UUID;

public class UHCPlayer extends CombatPlayerImpl {
    @Getter private boolean spectating;
    @Getter @Setter private Team UHCTeam = Teams.VILLAGERS.get();
    @Getter @Setter private Role UHCRole = Roles.VILLAGER.get();
    public int minedDiamonds = 0;

    public UHCPlayer(@NotNull UUID uuid, @NotNull String username, @NotNull PlayerConnection playerConnection) {
        super(uuid, username, playerConnection);
    }

    public void toggleSpectating() {
        if (isSpectating()) {
            spectating = false;

            sendPacket(new WorldBorderSizePacket(getInstance().getWorldBorder().diameter()));
            setGameMode(GameMode.SURVIVAL);
            setCanPickupItem(true);
            setInvulnerable(false);
            setSilent(false);
            this.collidesWithEntities = true;
            setInvisible(false);
            setFlying(false);
        } else {
            spectating = true;

            sendPacket(new WorldBorderSizePacket(0));
            setGameMode(GameMode.ADVENTURE);
            setCanPickupItem(false);
            setInvulnerable(true);
            setSilent(true);
            this.collidesWithEntities = false;
            setInvisible(true);
            setFlying(true);
            heal();
        }
    }
}
