package dev.ninjdai.werewolf.uhc.teams;

import dev.ninjdai.werewolf.Main;
import dev.ninjdai.werewolf.uhc.UHCPlayer;
import net.minestom.server.entity.GameMode;
import net.minestom.server.instance.Instance;
import org.jetbrains.annotations.NotNull;

import java.util.HashSet;
import java.util.Set;
import java.util.stream.Collectors;

public class WinCondition {
    public static Team winningTeam;
    public static boolean checkTeamWin(@NotNull Team team, @NotNull Set<UHCPlayer> players){
        switch (team.getWinConditionType()){
            case WinConditionType.ONLY_TEAM_REMAINING -> {
                for (UHCPlayer player: players) {
                    if (!(player.getUHCTeam() == team)) return false;
                }
                return true;
            }
        }
        return false;
    }

    public static boolean checkWin(Set<UHCPlayer> inGamePlayers) {
        Main.LOGGER.info(inGamePlayers.toString());
        for (Teams team: Teams.values()) {
            Main.LOGGER.info("Checking if team {} wins...", team.get().getName());
            if(checkTeamWin(team.get(), inGamePlayers)){
                winningTeam = team.get();
                Main.LOGGER.info("Team {} wins !", team.get().getName());
                return true;
            }
        }
        return false;
    }

    public static Set<UHCPlayer> inGamePlayers(Instance instance) {
        Set<UHCPlayer> players = HashSet.newHashSet(instance.getPlayers().size());
        instance.getPlayers().forEach((player -> players.add((UHCPlayer) player)));
        return players.stream().filter((p) -> p.getGameMode()== GameMode.SURVIVAL).collect(Collectors.toSet());
    }

    public enum WinConditionType {
        ONLY_TEAM_REMAINING,
    }
}
